{{ form_start(form) }}
<div>
    {{ form_errors(form) }}
</div>
{{ form_row(form.name) }}
{{ form_row(form.description) }}
{{ form_row(form.tenants) }}
<hr>
{{ form_row(form.schema) }}
{{ form_row(form.version) }}
{{ form_row(form.host) }}
{{ form_row(form.port) }}
{{ form_row(form.use_proxy) }}
{{ form_row(form.use_ssl) }}
{{ form_row(form.use_tls) }}
{{ form_row(form.follow_referrals) }}
{{ form_row(form.timeout) }}
{{ form_row(form.custom_options) }}
<div class="form-group select">
    <label class="control-label" for="add-ldap-append-custom-option">Ajouter une option</label>
    <div class="form-group-wrapper">
        <select class="form-control" onchange="appendLdapOption(this)" id="add-ldap-append-custom-option">
            <option value="">-- Sélectionner une option --</option>
            {% for value, text in form.vars.data.getSelectCustomOptions() %}
                <option value="{{ value }}">{{ text }}</option>
            {% endfor %}
        </select>
        <p class="help-block">
            <a href="https://www.php.net/ldap_set_option" target="_blank">https://www.php.net/ldap_set_option</a>
        </p>
    </div>
</div>
<button type="button" class="btn btn-default" onclick="pingLdap(this)">Ping</button>
<hr>
{{ form_row(form.user_query_login) }}
{{ form_row(form.user_query_password) }}
{{ form_row(form.ldap_root_search) }}
<button type="button" class="btn btn-default" onclick="getLdapEntry(this)">
    Récupérer une entrée LDAP
</button>
<hr>
{{ form_row(form.ldap_users_filter) }}
<button type="button" class="btn btn-default" onclick="countLdapEntries(this)">Compter les entrées LDAP (avec filtre)</button>
<hr>

<div class="fixtips alert alert-info">
    <i class="fa fa-lightbulb-o fa-space" aria-hidden="true"></i>exemples:<br>
    <span title="prefix" class="tips-prefix" style="">uid=</span>
    <span title="username" class="disabled gray">admin</span>
    <span title="suffix" class="tips-suffix">,ou=users,dc=libriciel,dc=fr</span><br>

    <span title="username" class="disabled gray">admin</span>
    <span title="suffix" class="tips-suffix">@libriciel.fr</span>
</div>
<div class="form-group">
    <button type="button" class="btn btn-default" onclick="prefixSuffixAuto(this)">Prefix/suffix auto</button>
</div>
{{ form_row(form.account_prefix) }}
{{ form_row(form.account_suffix) }}

<div class="form-group">
    <button type="button" class="btn btn-default" onclick="$('#tmp6579cfb307003').slideToggle()">Afficher/cacher le test de connexion</button>
</div>
<div style="display: none" id="tmp6579cfb307003">

    {{ form_row(form.test_username) }}
    {{ form_row(form.test_password) }}
    <button type="button" class="btn btn-default" onclick="testConnection(this)">Envoyer le test</button>
</div>
<hr>

<div class="form-group">
    <button type="button" class="btn btn-default" onclick="mappingAuto(this)">Mapping auto</button>
</div>

{{ form_widget(form) }}

<button type="button" class="btn btn-default" onclick="getFilteredLdapEntry(this)">
    Récupérer une entrée filtrée/mappée
</button>

<button type="submit" class="btn btn-primary hide">Hidden submit</button>
{{ form_end(form) }}

<script id="jsFormTemplateInput" type="text/x-jsrender" data-jsv-tmpl="jsvTmpl">
{{ '
    <div class="form-group {{:type}}{{if required}} required{{/if}}">
        <label class="control-label" for="{{:id}}">{{:label}}</label>
        <div class="form-group-wrapper">
            <input type="{{:type}}" name="{{:name}}" class="form-control {{:class}}" id="{{:id}}" data-fullname="{{:fullname}}" placeholder="{{:placeholder}}" pattern="{{:pattern}}"{{if required}} required="required"{{/if}} min="{{:min}}" max="{{:max}}" aria-required="true" />
            <p class="help-block">{{:help}}</p>
        </div>
    </div>
' }}
</script>
<!--suppress JSUnusedAssignment, FunctionTooLongJS -->
<script>
    function pingLdap(btn) {
        let form = $(btn).closest('form');
        $(btn).disable();
        $.ajax({
            url: '{{ url('admin_ping_ldap') }}',
            method: 'POST',
            data: form.serialize(),
            success: (content) => alert(content === 'ping' ? 'pong!' : 'error'),
            error: function(e) {
                e.responseText
                    ? alert(e.responseText)
                    : alert(e)
                ;
            },
            complete: ()  => $(btn).enable(),
        })
    }
    function getLdapEntry(btn) {
        var form = $(btn).closest('form');
        $(btn).disable();
        $.ajax({
            url: '{{ url('admin_random_entry_ldap') }}',
            method: 'POST',
            data: form.serialize(),
            success: function(content) {
                let str = '';
                for(var key in content) {
                    str += key + ' : ' + content[key] + '\n';
                }
                alert(str);
            },
            error: function(e) {
                if (e.responseText) {
                    alert(e.responseText);
                } else {
                    alert(e);
                }
            },
            complete: function() {
                $(btn).enable();
            }
        })
    }
    function countLdapEntries(btn) {
        var form = $(btn).closest('form');
        $(btn).disable();
        $.ajax({
            url: '{{ url('admin_ldap_count') }}',
            method: 'POST',
            data: form.serialize(),
            success: function(content) {
                alert(content);
            },
            error: function(e) {
                if (e.responseText) {
                    alert(e.responseText);
                } else {
                    alert(e);
                }
            },
            complete: function() {
                $(btn).enable();
            }
        });
    }

    function getFilteredLdapEntry(btn) {
        let form = $(btn).closest('form');
        $(btn).disable();
        $.ajax({
            url: '{{ url('admin_ldap_filtered') }}',
            method: 'POST',
            data: form.serialize(),
            success: function(content) {
                let str = '';
                for(var key in content) {
                    str += key + ' : ' + content[key] + '\n';
                }
                alert(str);
            },
            error: function(e) {
                e.responseText
                    ? alert(e.responseText)
                    : alert(e)
                ;
            },
            complete: ()  => $(btn).enable(),
        })
    }


    function optTextToInt() {
        const TYPES_INTS = {{ form.vars.data.getSelectCustomOptionsIntegers()|json_encode|raw }};
        var input;
        for (var i = 0; i < TYPES_INTS.length; i++) {
            input = $('#' + TYPES_INTS[i]).attr('type', 'number');
        }
    }
    function appendLdapOption(element)
    {
        element = $(element);
        var value = element.val();
        if (!value) {
            return;
        }
        var button = $('<button type="button" class="close"><span>×</span></button>')
            .attr('aria-label', "Supprimer l'option " + value);
        button.on('click', () => {
            var parent = $(this).parent();
            var form = parent.closest("form");
            parent.slideUp(400, () => {
                parent.remove();
                form.change();
            });
            var hidden = $('#ldap_custom_options');
            var customOpts = JSON.parse(hidden.val() ? hidden.val() : '""');
            customOpts = customOpts ? customOpts : {};
            delete customOpts[value];
            hidden.val(JSON.stringify(customOpts));
        });
        var div = $('<div class="filter-container"></div>')
            .append(button)
            .append(Form.input(value, {name: 'custom_options['+value+']'}));
        element.closest('.form-group').after(div);
        element.val('');
        var input = div.find('input').focus();
        input.removeAttr('name');
        input.on('change', () => {
            var hidden = $('#ldap_custom_options');
            var customOpts = JSON.parse(hidden.val() ? hidden.val() : '""');
            customOpts = customOpts ? customOpts : {};
            customOpts[value] = input.val();
            hidden.val(JSON.stringify(customOpts));
        })
        optTextToInt();
    }

    function prefixSuffixAuto()
    {
        var queryLogin = $('[name="{{ form.user_query_login.vars.full_name }}"]:visible').val();
        if (!queryLogin) {
            return;
        }
        var schema = $('[name="{{ form.schema.vars.full_name }}"]:visible').val();
        if (schema === 'Adldap\\Schemas\\ActiveDirectory') {
            var domain = queryLogin
                .split(',')
                .filter((v) => v.substr(0, 2) === 'dc')
                .map((v) => v.substr(3))
                .join('.');
            $('[name="{{ form.account_prefix.vars.full_name }}"]:visible').val('');
            $('[name="{{ form.account_suffix.vars.full_name }}"]:visible').val('@'+domain);
        } else {
            var adminusername = queryLogin
                .split(',')
                .filter((v) => v.substr(0, 2) !== 'dc' && v.substr(0, 2) !== 'ou')[0];
            adminusername = adminusername.substr(adminusername.indexOf('=') +1);
            var fixes = queryLogin.split(adminusername);
            // l'admin est souvent dans un autre groupe, on récupère donc le DN de base
            if (fixes[1][0] === ',') {
                fixes[1] = ','+$('[name="{{ form.ldap_root_search.vars.full_name }}"]:visible').val();
            }
            $('[name="{{ form.account_prefix.vars.full_name }}"]:visible').val(fixes[0]); // ex: uid=
            $('[name="{{ form.account_suffix.vars.full_name }}"]:visible').val(fixes[1]); // ex: ,ou=test,dc=libriciel,dc=fr
        }
    }

    function testConnection(btn) {
        var form = $(btn).closest('form');
        $(btn).disable();
        $.ajax({
            url: '{{ url('admin_ldap_test') }}',
            method: 'POST',
            data: form.serialize(),
            success: function(content) {
                alert(content);
            },
            error: function(e) {
                if (e.responseText) {
                    alert(e.responseText);
                } else {
                    alert(e);
                }
            },
            complete: function() {
                $(btn).enable();
            }
        });
    }

    function mappingAuto(btn) {
        var form = $(btn).closest('form');
        $(btn).disable();
        $.ajax({
            url: '{{ url('admin_ldap_list_available_attributes') }}',
            method: 'POST',
            data: form.serialize(),
            success: function(content) {
                var lowercase = content.map((v) => v.toLowerCase());
                var ldap_login_fields = ['samaccountname', 'uid', 'cn'];
                var ldap_username_fields = ['samaccountname', 'uid', 'cn'];
                var ldap_name_fields = ['cn', 'commonname', 'displayname', 'name', 'givenname', 'sn'];
                var ldap_mail_fields = ['mail', 'rfc822mailbox', 'mailrfc822mailbox'];
                var login = $('[name="{{ form.account_prefix.vars.full_name }}"]:visible').val().replace(/(.*,)?=$/g, '');
                var user_query_login = $('[name="{{ form.user_query_login.vars.full_name }}"]:visible').val();
                var index = 0;
                if (!login) {
                    user_query_login = user_query_login
                        .split(',')
                        .filter((v) => v.substr(0, 2) !== 'dc' && v.substr(0, 2) !== 'ou')[0];
                    login = user_query_login.substr(0, user_query_login.indexOf('='));
                }
                ldap_login_fields.unshift(login);
                for (var i = 0; i < ldap_login_fields.length; i++) {
                    index = lowercase.indexOf(ldap_login_fields[i]);
                    if (index > 0) {
                        $('[name="{{ form.user_login_attribute.vars.full_name }}"]:visible').val(content[index]);
                        break;
                    }
                }
                for (i = 0; i < ldap_username_fields.length; i++) {
                    index = lowercase.indexOf(ldap_username_fields[i]);
                    if (index > 0) {
                        $('[name="{{ form.user_username_attribute.vars.full_name }}"]:visible').val(content[index]);
                        break;
                    }
                }
                for (i = 0; i < ldap_name_fields.length; i++) {
                    index = lowercase.indexOf(ldap_name_fields[i]);
                    if (index > 0) {
                        $('[name="{{ form.user_name_attribute.vars.full_name }}"]:visible').val(content[index]);
                        break;
                    }
                }
                for (i = 0; i < ldap_mail_fields.length; i++) {
                    index = lowercase.indexOf(ldap_mail_fields[i]);
                    if (index > 0) {
                        $('[name="{{ form.user_mail_attribute.vars.full_name }}"]:visible').val(content[index]);
                        break;
                    }
                }
            },
            error: function(e) {
                if (e.responseText) {
                    alert(e.responseText);
                } else {
                    alert(e);
                }
            },
            complete: function() {
                $(btn).enable();
            }
        });
    }
</script>
